#include "../mdk/mdk.h"
#include <windows.h>

#pragma optimize ("awy", on) 

void (__cdecl *ovl_SetMICallbacks)(CMICallbacks * cmi);

CMachineParameter const *pParameters[] = { NULL };
CMachineAttribute const *pAttributes[] = { NULL };

#pragma pack(1)		

#pragma pack()

CMachineInfo const MacInfo = 
{
	MT_EFFECT,
	MI_VERSION,	
	MIF_DOES_INPUT_MIXING,
	0,										// min tracks
	0,										// max tracks
	0,										// numGlobalParameters
	0,										// numTrackParameters
	pParameters,
	0,
	pAttributes,
	"TempCMIAdd",								// name
	"(keep me)",								// short name
	"TempCMI",						// author
	"x"
};

HINSTANCE dllInstance;

class miex : public CMDKMachineInterfaceEx { };

class mi : public CMDKMachineInterface
{
public:
	mi();
	virtual ~mi();
	virtual void Tick();
	virtual void MDKInit(CMachineDataInput * const pi);
	virtual bool MDKWork(float *psamples, int numsamples, int const mode);
	virtual bool MDKWorkStereo(float *psamples, int numsamples, int const mode);
	virtual void Command(int const i);
	virtual void MDKSave(CMachineDataOutput * const po);
	virtual char const *DescribeValue(int const param, int const value);

public:
	virtual CMDKMachineInterfaceEx *GetEx() { return &ex; }
	virtual void OutputModeChanged(bool stereo) {}

public:
	miex ex;

public:
	int track_id;
	CMachine *ThisMachine;
};


mi::mi() { }
mi::~mi() { }

void mi::MDKInit(CMachineDataInput * const pi)
{
	SetOutputMode( true );
	ThisMachine = pCB->GetThisMachine();
	try {
		ovl_SetMICallbacks(pCB);
	} catch (...) {
	}
}

void mi::MDKSave(CMachineDataOutput * const po) { }

void mi::Tick() { }

bool mi::MDKWork(float *psamples, int numsamples, int const mode)
{
	return false;
}

bool mi::MDKWorkStereo(float *psamples, int numsamples, int const mode)
{
	return false;
}


BOOL WINAPI DllMain ( HANDLE hModule, DWORD fwdreason, LPVOID lpReserved ) {
	switch (fwdreason) {
	case DLL_PROCESS_ATTACH: {
		char baba[256], baba2[256];
		char *filen;
		int len;
		int i;

		dllInstance = (HINSTANCE) hModule;
		GetModuleFileName(dllInstance,baba,256);
		GetFullPathName(baba,256,baba2,&filen);
		filen[0] = 0;
		len = strlen(baba2);
		baba2[len-1] = 0;
		for (i = len-2; i > 0; --i) {
			if (baba2[i] == '\\') {
				baba2[i] = 0;
				break;
			}
		}
		strcat(baba2, "\\CyanPhase New Buzz Overloader.dll");
		HMODULE h_dll=LoadLibrary(baba2);
		if (h_dll != NULL) {
			ovl_SetMICallbacks=(void (__cdecl *)(CMICallbacks *))GetProcAddress(h_dll,"SetMICallbacks");
		} else {
			MessageBox(NULL, "Could not find CyanPhase New Buzz Overloader (note: is an updated version only for the new buzz)", "", MB_OK);
		}
		break;
	}
	case DLL_THREAD_ATTACH: break;
	case DLL_THREAD_DETACH: break;
	case DLL_PROCESS_DETACH: break;
	}
	return TRUE;
}


void mi::Command(int const i) { }

char const *mi::DescribeValue(int const param, int const value)
{
	return NULL;
}

#pragma optimize ("", on) 

DLL_EXPORTS

